package vpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeExpressConnectTrafficQosQueue invokes the vpc.DescribeExpressConnectTrafficQosQueue API synchronously
func (client *Client) DescribeExpressConnectTrafficQosQueue(request *DescribeExpressConnectTrafficQosQueueRequest) (response *DescribeExpressConnectTrafficQosQueueResponse, err error) {
	response = CreateDescribeExpressConnectTrafficQosQueueResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeExpressConnectTrafficQosQueueWithChan invokes the vpc.DescribeExpressConnectTrafficQosQueue API asynchronously
func (client *Client) DescribeExpressConnectTrafficQosQueueWithChan(request *DescribeExpressConnectTrafficQosQueueRequest) (<-chan *DescribeExpressConnectTrafficQosQueueResponse, <-chan error) {
	responseChan := make(chan *DescribeExpressConnectTrafficQosQueueResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeExpressConnectTrafficQosQueue(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeExpressConnectTrafficQosQueueWithCallback invokes the vpc.DescribeExpressConnectTrafficQosQueue API asynchronously
func (client *Client) DescribeExpressConnectTrafficQosQueueWithCallback(request *DescribeExpressConnectTrafficQosQueueRequest, callback func(response *DescribeExpressConnectTrafficQosQueueResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeExpressConnectTrafficQosQueueResponse
		var err error
		defer close(result)
		response, err = client.DescribeExpressConnectTrafficQosQueue(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeExpressConnectTrafficQosQueueRequest is the request struct for api DescribeExpressConnectTrafficQosQueue
type DescribeExpressConnectTrafficQosQueueRequest struct {
	*requests.RpcRequest
	ClientToken          string           `position:"Query" name:"ClientToken"`
	QosId                string           `position:"Query" name:"QosId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	QueueIdList          *[]string        `position:"Query" name:"QueueIdList"  type:"Repeated"`
	QueueNameList        *[]string        `position:"Query" name:"QueueNameList"  type:"Repeated"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeExpressConnectTrafficQosQueueResponse is the response struct for api DescribeExpressConnectTrafficQosQueue
type DescribeExpressConnectTrafficQosQueueResponse struct {
	*responses.BaseResponse
	RequestId string          `json:"RequestId" xml:"RequestId"`
	QueueList []QueueListItem `json:"QueueList" xml:"QueueList"`
}

// CreateDescribeExpressConnectTrafficQosQueueRequest creates a request to invoke DescribeExpressConnectTrafficQosQueue API
func CreateDescribeExpressConnectTrafficQosQueueRequest() (request *DescribeExpressConnectTrafficQosQueueRequest) {
	request = &DescribeExpressConnectTrafficQosQueueRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Vpc", "2016-04-28", "DescribeExpressConnectTrafficQosQueue", "vpc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeExpressConnectTrafficQosQueueResponse creates a response to parse from DescribeExpressConnectTrafficQosQueue response
func CreateDescribeExpressConnectTrafficQosQueueResponse() (response *DescribeExpressConnectTrafficQosQueueResponse) {
	response = &DescribeExpressConnectTrafficQosQueueResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
